#include "stdafx.h"
#include "web_to_offline.h"
#define MAX_SIZE 512
#define SINGLE_QUOT 0x27
#define dptr (LPDWORD)
#define wptr (PUSHORT)
#define sxb (LPSTR)
#define D_LOWER 0x20202020
#define MAX_LOG_SIZE (4<<20)
typedef LPSTR *LPPSTR;
typedef struct{
	HANDLE hFile;		//FILE`S HANDLE
	DWORD BufferSize;	//SIZE OF BUFFER WITH CONTENT OF THE FILE
	LPSTR lpCode;		//POINTER TO CONTENT OF THE FILE
	DWORD cSize;		//SIZE OF FILE
	LPSTR lpSearch;		//POINTER - WHERE FROM BEGINS LOOKING FOR A NEXT TAG WITHIN URL
	LPSTR fBase;		//BASE DIRECTORY
	LPSTR uBase;		//BASE URL
	LPSTR URL;			//URL - WHERE FROM DOWNLOAD A FILE
	LPSTR PATH;			//FULL FILE`S NAME
}HTML,*PHTML;
//PROTO
ATOM MyRegisterClass(HINSTANCE hInstance);
BOOL InitInstance(HINSTANCE, int);
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK About(HWND, UINT, WPARAM, LPARAM);
void URLToAbsoluteURL(LPSTR pUrl,LPSTR pBase);
void FixExtension(LPSTR pPath,LPSTR ext);
DWORD SizeURL(PHTML psHtm);
void DeleteString(PHTML psHtm,LPSTR pStr,DWORD Len);
void ReplaceUnwantedChars(LPSTR pPath);
void ReplaceURLByRelativePath(PHTML psHtm,LPSTR pUrl,LPSTR pPath);
BOOL InsertString(PHTML psHtm,LPSTR pMem,LPSTR pStr);
LPSTR SelectNextUrl(PHTML psHtm2,PHTML psHtm);
BOOL PrepareNextUrl(PHTML psNextHtm,PHTML psHtm);
void RightSlash(LPSTR pPath);
void LeftSlash(LPSTR pPath);
BOOL LoadHtm(PHTML psHtm);
BOOL IsHtml(PHTML psHtm);
void GetCurrentBase(PHTML psHtm);
void WebLoad(PHTML psHtm);
void SaveFile(PHTML psHtm);
int CALLBACK StartLoad(HWND hWnd);
DWORD CALLBACK SizeURL2(PHTML psHtm);
void CALLBACK LoadHtm2(PHTML psHtm);
//.data?
HINTERNET hInt;
HANDLE hThreadSize;
ULONG ThreadIDSize;
HANDLE hThreadLoad;
ULONG ThreadIDLoad;
DWORD Loaded;
DWORD gSize;
HANDLE hThread;
ULONG ThreadID;
HINSTANCE hInst;
HWND hWin;
LPPSTR pArrayOfUnique;
HANDLE hLog;
LPSTR pLog;
DWORD httpscheme;
char URL[MAX_PATH];
char BaseURL[MAX_PATH];
char Path[MAX_PATH];
char CurrHeader[1024];
char Zone[128];
char ErrBuff[1024];
char HelpFile[MAX_PATH];
char HelpDir[MAX_PATH];
char StartUrl[MAX_SIZE];
char StartDir[MAX_SIZE];
char FirstFile[MAX_SIZE];
WCHAR CurrWide[MAX_SIZE];
DWORD lenZone;
DWORD LevelLoad;
DWORD MaxFileSize;
DWORD Stop;
LPSTR pCurrLog;
DWORD dwRW;
DWORD MaxFileNum;
DWORD sizeLog;
BROWSEINFO binf;
LPITEMIDLIST iil;
//.const
const char ContentLength[]="content-length:";
const char ContentType[]="content-type:";
const char PatternState[]="Current URL: %s\r\nCurrent File: %s\r\nSize Of File: %u byte %s\r\nLink got from the file: %s\r\nCurrent Base: %s\r\nHeader:\r\n%s\n****\r\n";
const char Yes[]="and it is allowed size";
const char No[]="and it is not allowed size";
const char BeginComment[]="<!--";
const char EndComment[]="-->";
const char ClassName[]="WTO_MAIN";
const char AppName[]="Web To Offline";
const char AboutMsg[]="Web To Offline //// Sotnikov Vasiliy 2012\r\nemail: dsmhelp@yandex.ru";
const char logfile[]="logfile.txt";
const char FirstPattern[]="First URL: %s\r\nFirst file: %s\r\n****\r\n";
const char ChooseDir[]="Choose Empty Folder";
//.code
int APIENTRY _tWinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPTSTR lpCmdLine,int nCmdShow){
MSG msg;
HACCEL hAccelTable;
WNDCLASSEX wc;
LPSTR xPtr;
	Stop=0;
	hInst=GetModuleHandle(0);
	GetModuleFileName(hInst,HelpFile,sizeof(HelpFile));
	xPtr=HelpFile;
	while (xPtr[0]!=0) ++xPtr;
	while (xPtr>&HelpFile[0] && xPtr[0]!='/' && xPtr[0]!='\\') --xPtr;
	xPtr[1]=0;
	strcpy(HelpDir,HelpFile);
	strcat(HelpFile,"\\readme.htm");
	wc.cbSize=sizeof(wc);
	wc.style=CS_HREDRAW|CS_VREDRAW;
	wc.lpfnWndProc=&WndProc;
	wc.cbClsExtra=NULL;
	wc.cbWndExtra=DLGWINDOWEXTRA;
	wc.hInstance=hInst;
	wc.hbrBackground=(HBRUSH)(COLOR_BTNFACE+1);
	wc.lpszMenuName=sxb IDM_WEB_TO_OFFLINE;
	wc.lpszClassName=sxb &ClassName;
	wc.hIcon=LoadIcon(hInst,(LPCTSTR)IDI_WEB_TO_OFFLINE);
	wc.hIconSm=LoadIcon(hInst,(LPCTSTR)IDI_SMALL);
	wc.hCursor=LoadCursor(NULL,IDC_ARROW);
	RegisterClassEx(&wc);
	CreateDialogParam(hInst,(LPCSTR)IDD_MAIN,NULL,(DLGPROC)&WndProc,NULL);
	hAccelTable=LoadAccelerators(hInst,(LPCTSTR)IDC_WEB_TO_OFFLINE);
	while (GetMessage(&msg,NULL,0,0)){
		if (TranslateAccelerator(msg.hwnd,hAccelTable,&msg)) continue;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	};
	ExitProcess((int) msg.wParam);
	return (int) msg.wParam;
};
LRESULT CALLBACK WndProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam){
USHORT nCode,ido;
	if (message==WM_INITDIALOG){
		hWin=hWnd;
		SetDlgItemText(hWnd,MAX_FILE_SIZE,"5000");
		SetDlgItemText(hWnd,START_URL,"http://dsmhelp.narod.ru/index.htm");
		SetDlgItemText(hWnd,START_DIR,"C:\\dsmhelp");
		SetDlgItemText(hWnd,MAX_FILE_NUM2,"10239");
		SetDlgItemText(hWnd,LEVEL_LOAD,"20");
		SetDlgItemText(hWnd,R_ZONE,"dsmhelp.narod.ru");
	}else if (message==WM_COMMAND){
		ido=LOWORD(wParam);
		nCode=HIWORD(wParam);
		if (lParam==0){
			if (ido==IDM_FILE_EXIT){
				SendMessage(hWnd,WM_CLOSE,0,0);
			}else if (ido==IDM_LOAD){
				hThread=CreateThread(NULL,128<<10,(LPTHREAD_START_ROUTINE) &StartLoad,hWnd,NULL,&ThreadID);
			}else if (ido==IDM_HELP_ABOUT){
				ShellAbout(hWnd,AppName,AboutMsg,NULL);
			}else if (ido==IDM_HELP){
				ShellExecute(hWnd,"open",HelpFile,NULL,HelpDir,SW_SHOW);
			};
		}else{
			if (nCode==BN_CLICKED){
				if (ido==START_BUTTON){
					hThread=CreateThread(NULL,128<<10,(LPTHREAD_START_ROUTINE) &StartLoad,hWnd,NULL,&ThreadID);
				}else if (ido==DIR_BUTTON){
					binf.hwndOwner=hWnd;
					binf.pidlRoot=0;
					binf.pszDisplayName=0;
					binf.lpszTitle=ChooseDir;
					binf.ulFlags=0;
					binf.lpfn=0;
					binf.lParam=0;
					binf.iImage=0;
					iil=SHBrowseForFolder(&binf);
					if (iil!=0){
						SHGetPathFromIDList(iil,StartDir);
						SetDlgItemText(hWnd,START_DIR,StartDir);
					};
				}else if (ido==STOP_BUTTON){
					EnableWindow(GetDlgItem(hWnd,STOP_BUTTON),FALSE);
					EnableWindow(GetDlgItem(hWnd,CONT_BUTTON),TRUE);
					Stop=1;
					SetDlgItemText(hWnd,ERR_OUTPUT,"Stopped...");
				}else if (ido==CONT_BUTTON){
					EnableWindow(GetDlgItem(hWnd,STOP_BUTTON),TRUE);
					EnableWindow(GetDlgItem(hWnd,CONT_BUTTON),FALSE);
					Stop=0;
					SetDlgItemText(hWnd,ERR_OUTPUT,"Continued...");
				};
			};
		};
	}else if (message==WM_CLOSE){
		DestroyWindow(hWnd);
	}else if (message==WM_DESTROY){
		PostQuitMessage(0);
	}else{
		return DefWindowProc(hWnd,message,wParam,lParam);	
	};
	return 0;
};
int CALLBACK StartLoad(HWND hWnd){
HTML FFile;
LPSTR xPtr;
DWORD PathLen,xCnt;
	FFile.fBase=0;
	FFile.uBase=0;
	hInt=InternetOpen(AppName,0,0,0,0);
	EnableWindow(GetDlgItem(hWnd,STOP_BUTTON),TRUE);
	EnableWindow(GetDlgItem(hWnd,CONT_BUTTON),FALSE);
	LevelLoad=GetDlgItemInt(hWnd,LEVEL_LOAD,0,0);
	MaxFileSize=GetDlgItemInt(hWnd,MAX_FILE_SIZE,0,0)<<10;
	GetDlgItemText(hWnd,R_ZONE,Zone,sizeof(Zone));
	lenZone=strlen(Zone);
	GetDlgItemText(hWnd,START_URL,StartUrl,sizeof(StartUrl));
	FFile.URL=sxb VirtualAlloc(0,MAX_SIZE,MEM_COMMIT,PAGE_READWRITE);
	strcpy(FFile.URL,StartUrl);
	GetDlgItemText(hWnd,START_DIR,StartDir,sizeof(StartDir));
	MakeSureDirectoryPathExists(StartDir);
	SetCurrentDirectory(StartDir);
	xPtr=strchr(StartUrl,':');
	xPtr+=3;
	strcpy(FirstFile,xPtr);
	FFile.PATH=sxb VirtualAlloc(0,MAX_SIZE,MEM_COMMIT,PAGE_READWRITE);
	strcpy(FFile.PATH,FirstFile);
	PathLen=strlen(FFile.PATH);
	if (FFile.PATH[PathLen-1]=='/' || FFile.PATH[PathLen-1]=='\\'){
		(dptr &FFile.PATH[PathLen+0])[0]='edni';
		(dptr &FFile.PATH[PathLen+4])[0]='th.x';
		(dptr &FFile.PATH[PathLen+8])[0]='m';
	};
	ReplaceUnwantedChars(FFile.PATH);
	MaxFileNum=GetDlgItemInt(hWnd,MAX_FILE_NUM2,NULL,FALSE);
	pArrayOfUnique=(LPPSTR) VirtualAlloc(0,MaxFileNum*sizeof(LPSTR)+sizeof(LPSTR),MEM_COMMIT,PAGE_READWRITE);
	xCnt=MaxFileNum;
	pArrayOfUnique[xCnt]=sxb 1;
	do{
		--xCnt;
		pArrayOfUnique[xCnt]=sxb 1;
	}while (xCnt!=0);
	pArrayOfUnique[0]=FFile.PATH;
	hLog=CreateFile(logfile,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ,0,OPEN_EXISTING,0,0);
	if (hLog==INVALID_HANDLE_VALUE){
		hLog=CreateFile(logfile,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_ALWAYS,0,0);
	};
	sizeLog=GetFileSize(hLog,0);
	pLog=sxb VirtualAlloc(NULL,MAX_LOG_SIZE,MEM_COMMIT,PAGE_READWRITE);
	ReadFile(hLog,pLog,sizeLog,&dwRW,NULL);
	pLog[sizeLog]=0;
	pCurrLog=&pLog[sizeLog];
	wsprintf(pCurrLog,FirstPattern,FFile.URL,FFile.PATH);
	while (pCurrLog[0]!=0) ++pCurrLog;
	FFile.cSize=0;
	WebLoad(&FFile);
	xCnt=1;
	while (pArrayOfUnique[xCnt]!=sxb 1){
		VirtualFree(pArrayOfUnique[xCnt],MAX_SIZE,MEM_DECOMMIT);
		++xCnt;
	};
	VirtualFree(pArrayOfUnique,MaxFileNum*sizeof(LPSTR)+sizeof(LPSTR),MEM_DECOMMIT);
	MessageBox(hWnd,"All Downloaded.","Ready",MB_ICONEXCLAMATION);
	SetFilePointer(hLog,0,0,FILE_BEGIN);
	WriteFile(hLog,pLog,strlen(pLog),&dwRW,NULL);
	VirtualFree(pLog,MAX_LOG_SIZE,MEM_DECOMMIT);
	EnableWindow(GetDlgItem(hWnd,STOP_BUTTON),FALSE);
	EnableWindow(GetDlgItem(hWnd,CONT_BUTTON),FALSE);
	InternetCloseHandle(hInt);
	return 0;
};
void WebLoad(PHTML psHtm){
HTML NextFile;
LPPSTR xPtr;
BOOL IsEqual;
	NextFile.fBase=0;
	--LevelLoad;
	if (LevelLoad<0x80000000){
		if (LoadHtm(psHtm)!=0){
			if (IsHtml(psHtm)!=FALSE){
				GetCurrentBase(psHtm);
				while (PrepareNextUrl(&NextFile,psHtm)!=0){
					if (MaxFileNum==1){
						if (GetFileAttributes(NextFile.PATH)==0xFFFFFFFF){
							WebLoad(&NextFile);
						};
					}else{
						xPtr=pArrayOfUnique;
						IsEqual=1;
						do{
							if (xPtr[0]==sxb 1) break;
							IsEqual=_strcmpi(NextFile.PATH,xPtr[0]);
							++xPtr;
						}while (IsEqual!=0);
						if (IsEqual!=0){
							xPtr[0]=NextFile.PATH;
							WebLoad(&NextFile);
						};
					};
				};
			};
			SaveFile(psHtm);
		};
	}else if (LevelLoad==0xFFFFFFFF){
		if (LoadHtm(psHtm)!=0){
			SaveFile(psHtm);
		};
	};
	++LevelLoad;
};
void SaveFile(PHTML psHtm){
	SetFilePointer(psHtm->hFile,0,0,FILE_BEGIN);
	WriteFile(psHtm->hFile,psHtm->lpCode,psHtm->cSize,&dwRW,0);
	SetEndOfFile(psHtm->hFile);
	CloseHandle(psHtm->hFile);
	VirtualFree(psHtm->hFile,psHtm->BufferSize,MEM_DECOMMIT);
	if (psHtm->fBase!=0){
		VirtualFree(psHtm->fBase,MAX_SIZE,MEM_DECOMMIT);
		VirtualFree(psHtm->uBase,MAX_SIZE,MEM_DECOMMIT);
	};
	VirtualFree(psHtm->URL,MAX_SIZE,MEM_DECOMMIT);
	if (MaxFileNum==1){
		VirtualFree(psHtm->PATH,MAX_SIZE,MEM_DECOMMIT);
	};
};
BOOL IsHtml(PHTML psHtm){
LPSTR xPtr;
DWORD xCnt,qchar;
	xPtr=psHtm->lpCode;
	xCnt=psHtm->cSize;
	if (xCnt>512) xCnt=512;
	if (xCnt==0) return FALSE;
	do{
		qchar=(dptr &xPtr[0])[0]|D_LOWER;
		if (qchar=='lmth') break;
		++xPtr;
		--xCnt;
	}while (xCnt!=0);
	return xCnt;
};
BOOL LoadHtm(PHTML psHtm){
	if (psHtm->cSize>MaxFileSize || psHtm->cSize==0xFFFFFFFF){
		return FALSE;
	};
	if (GetFileAttributes(psHtm->PATH)==0xFFFFFFFF){
		MakeSureDirectoryPathExists(psHtm->PATH);
		Loaded=0;
		do{
			hThreadLoad=CreateThread(NULL,0,(LPTHREAD_START_ROUTINE) &LoadHtm2,psHtm,NULL,&ThreadIDLoad);
			while (Loaded==0){
				if (Stop!=0){
					TerminateThread(hThreadLoad,0);
					DeleteFile(psHtm->PATH);
					break;
				};
				Sleep(1500);
			};
			while (Stop!=0) Sleep(10000);
		}while (Loaded==0);
		if (Loaded!=1) return FALSE;
	};
	mbstowcs(CurrWide,psHtm->PATH,sizeof(CurrWide)<<1);
	psHtm->hFile=CreateFileW(CurrWide,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ,0,OPEN_EXISTING,0,0);
	psHtm->cSize=GetFileSize(psHtm->hFile,0);
	if (psHtm->cSize<10 || psHtm->hFile==INVALID_HANDLE_VALUE){
		CloseHandle(psHtm->hFile);
		return FALSE;
	};
	psHtm->BufferSize=psHtm->cSize+8192;
	psHtm->lpCode=sxb VirtualAlloc(0,psHtm->BufferSize,MEM_COMMIT,PAGE_EXECUTE_READWRITE);
	psHtm->lpSearch=psHtm->lpCode;
	ReadFile(psHtm->hFile,psHtm->lpCode,psHtm->cSize,&dwRW,0);
	psHtm->lpCode[psHtm->cSize]=0;
	return TRUE;
};
void CALLBACK LoadHtm2(PHTML psHtm){
	if (URLDownloadToFile(0,psHtm->URL,psHtm->PATH,0,0)==S_OK){
		Loaded=1;
	}else{
		Loaded=2;
	};
};
void GetCurrentBase(PHTML psHtm){
LPSTR BeginBase,EndBase;
LPSTR xPtr,pUrl;
DWORD xCnt,qchar;
char lc1,lc2;
	BeginBase=0;
	psHtm->uBase=sxb VirtualAlloc(0,MAX_SIZE,MEM_COMMIT,PAGE_READWRITE);
	psHtm->fBase=sxb VirtualAlloc(0,MAX_SIZE,MEM_COMMIT,PAGE_READWRITE);
	xPtr=psHtm->lpCode;
	xCnt=psHtm->cSize;
	do{
		++xPtr;
		--xCnt;
		if (xCnt==0) goto BaseIsNotExist;
		qchar=(dptr &xPtr[0])[0]|D_LOWER;
		if (qchar=='sab<') goto BaseIsExist;
	}while (qchar!='dob<');
BaseIsNotExist:
	strcpy(psHtm->fBase,psHtm->PATH);
	xPtr=strrchr(psHtm->fBase,'\\');
	if (xPtr!=0) xPtr[1]=0;
	(dptr &psHtm->uBase[0])[0]='ptth';
	(dptr &psHtm->uBase[3])[0]='//:p';
	strcpy(&psHtm->uBase[7],psHtm->fBase);
	RightSlash(psHtm->uBase);
	xPtr=strrchr(psHtm->uBase,'/');
	if ((wptr &xPtr[-2])[0]=='/:'){
		while (xPtr[0]!=0) ++xPtr;
		(wptr &xPtr[0])[0]='/';
		xPtr=psHtm->fBase;
		while (xPtr[0]!=0) ++xPtr;
		(wptr &xPtr[0])[0]='/';
	};
	return;
BaseIsExist:
	BeginBase=xPtr;
	while (xPtr[0]!='>') ++xPtr;
	EndBase=xPtr;
	xPtr=BeginBase;
	while (xPtr<(EndBase-5)){
		++xPtr;
		qchar=(dptr &xPtr[0])[0]|D_LOWER;
		if (qchar=='=fer') break;
	};
	if (qchar!='=fer') goto BaseIsNotExist;
	xPtr+=4;
	lc1=' ';
	lc2='"';
	pUrl=xPtr;
	if (xPtr[0]=='"'){
		lc1='"';
		++pUrl;
		++xPtr;
	};
	while (xPtr[0]!=lc1 && xPtr[0]!=lc2 && xPtr[0]!='>'){
		++xPtr;
	};
	lc1=xPtr[0];
	xPtr[0]=0;
	qchar=(dptr &pUrl[0])[0]|D_LOWER;
	if (qchar=='ptth'){
		strcpy(psHtm->fBase,&pUrl[7]);
	}else{
		strcpy(psHtm->fBase,&pUrl[0]);
	};
	LeftSlash(psHtm->fBase);
	if (qchar=='ptth'){
		strcpy(psHtm->uBase,pUrl);
	}else{
		(dptr &psHtm->uBase[0])[0]='ptth';
		(dptr &psHtm->uBase[3])[0]='//:p';
		strcpy(&psHtm->uBase[7],pUrl);
	};
	xPtr[0]=lc1;
	RightSlash(psHtm->uBase);
	xPtr=strrchr(psHtm->uBase,'/');
	if ((wptr &xPtr[-2])[0]=='/:'){
		while (xPtr[0]!=0) ++xPtr;
		(wptr &xPtr[0])[0]='/';
		xPtr=psHtm->fBase;
		while (xPtr[0]!=0) ++xPtr;
		(wptr &xPtr[0])[0]='/';
	};
	if (BeginBase!=0 && (dptr &BeginBase[-4])[0]!='--!>'){
		EndBase+=sizeof(BeginComment);
		InsertString(psHtm,BeginBase,sxb &BeginComment);
		InsertString(psHtm,EndBase,sxb &EndComment);
	};
};
void RightSlash(LPSTR pPath){
	while (pPath[0]!=0){
		if (pPath[0]=='\\') pPath[0]='/';
		++pPath;
	};
};
void LeftSlash(LPSTR pPath){
	while (pPath[0]!=0){
		if (pPath[0]=='/') pPath[0]='\\';
		++pPath;
	};
};
BOOL InsertString(PHTML psHtm,LPSTR pMem,LPSTR pStr){
DWORD Len;
	Len=strlen(pStr);
	if ((psHtm->cSize+Len)<psHtm->BufferSize){
		memmove(pMem+Len,pMem,psHtm->cSize-(pMem-psHtm->lpCode));
		psHtm->cSize+=Len;
		memmove(pMem,pStr,Len);
		return TRUE;
	}else{
		return FALSE;
	};
};
LPSTR SelectNextUrl(PHTML psHtm2,PHTML psHtm){
LPSTR BeginTag,EndTag,TagPtr,ZonePtr,ZonePtrEnd,QuotPtr,SpacePtr;
DWORD qchar1,qchar2,qchar3,qchar4,qbias,LenUrl;
	psHtm2->URL=0;
	while (TRUE){
		TagPtr=0;
		BeginTag=strchr(psHtm->lpSearch,'<');
		if (BeginTag==0) break;
		EndTag=strchr(BeginTag,'>');
		if (EndTag==0) break;
		EndTag[0]=0;
		TagPtr=BeginTag;
		while (TRUE){
			TagPtr=strchr(TagPtr,'=');
			if (TagPtr==0) break;
			++TagPtr;
			if (TagPtr[0]==SINGLE_QUOT) continue;
			qbias=0;
			if (TagPtr[0]=='"') qbias=1;
			qchar1=(dptr &TagPtr[qbias])[0]|D_LOWER;
			qchar2=(dptr &TagPtr[-5])[0]|D_LOWER;
			if (qchar2=='ferh' &&  TagPtr[-6]!='.' && !(qchar1=='liam' && TagPtr[qbias+6]==':')) break;
			qchar2=(dptr &TagPtr[-4])[0]|D_LOWER;
			if (qchar2=='=crs' && TagPtr[-5]!='.') break;
		};
		qchar1=(dptr &BeginTag[1])[0]|D_LOWER;
		if (TagPtr!=0){
			qchar3=(dptr &TagPtr[0])[0]|D_LOWER;
			qchar4=(dptr &TagPtr[1])[0]|D_LOWER;
			if ((qchar3=='ptth' || qchar4=='ptth') && qchar2!='=crs' && qchar1!='knil' && Zone[0]){
				ZonePtr=StrStrI(TagPtr,Zone);
				if (ZonePtr!=0){
					ZonePtrEnd=ZonePtr+lenZone;
					do{
						--ZonePtr;
					}while (ZonePtr[0]!='/' && ZonePtr>TagPtr);
					if (!(ZonePtr[-2]==':' && ZonePtr[-1]=='/' && (ZonePtrEnd[0]=='/' || ZonePtrEnd[0]=='"' || ZonePtrEnd[0]==' '))){
						TagPtr=0;
					};
				}else{
					TagPtr=0;
				};
			};
		};
		if (TagPtr!=0){
			if (TagPtr[0]=='"'){
				++TagPtr;
				QuotPtr=strchr(TagPtr,'"');
				if (QuotPtr==0) goto QuotAbsent;
				LenUrl=QuotPtr-TagPtr;
				if (psHtm2->URL==0){
					psHtm2->URL=sxb VirtualAlloc(0,MAX_SIZE,MEM_COMMIT,PAGE_READWRITE);
				};
				strncpy(psHtm2->URL,TagPtr,LenUrl);
				EndTag[0]='>';
				EndTag=QuotPtr;
			}else{
			QuotAbsent:
				SpacePtr=strchr(TagPtr,' ');
				if (SpacePtr==0) SpacePtr=EndTag;
				LenUrl=SpacePtr-TagPtr;
				if (psHtm2->URL==0){
					psHtm2->URL=sxb VirtualAlloc(0,MAX_SIZE,MEM_COMMIT,PAGE_READWRITE);
				};
				strncpy(psHtm2->URL,TagPtr,LenUrl);
				EndTag[0]='>';
				EndTag=SpacePtr;
			};
		};
		psHtm->lpSearch=EndTag;
		if (EndTag[0]==0) EndTag[0]='>';
		if (psHtm2->URL!=0){
			QuotPtr=strchr(psHtm2->URL,SINGLE_QUOT);
			if (QuotPtr!=0) TagPtr=0;
			QuotPtr=strchr(psHtm2->URL,'#');
			if (QuotPtr!=0){
				QuotPtr[0]=0;
				while (psHtm->lpSearch[0]!='#'){
					--psHtm->lpSearch;
				};
			};
		};
		if (TagPtr!=0) break;
	};
	return TagPtr;
};
BOOL PrepareNextUrl(PHTML psNextHtm,PHTML psHtm){
LPSTR pUrl,xPtr;
DWORD qchar,Attributes,sLen,fSize;
	pUrl=SelectNextUrl(psNextHtm,psHtm);
	if (pUrl!=0){
		RightSlash(psNextHtm->URL);
		xPtr=psNextHtm->URL;
		qchar=(dptr &xPtr[0])[0]|D_LOWER;
		if (qchar=='ptth'){
			if (xPtr[4]=='s' || xPtr[4]=='S') ++xPtr;
			xPtr+=7;
			while (xPtr[0]!='/' && xPtr[0]!=0){
				++xPtr;
			};
			if (xPtr[0]==0){
				(wptr &xPtr[0])[0]='/';
			};
		};
		psNextHtm->PATH=sxb VirtualAlloc(0,MAX_SIZE,MEM_COMMIT,PAGE_READWRITE);
		URLToAbsoluteURL(psNextHtm->URL,psHtm->uBase);
		httpscheme=1;
		if ((dptr psNextHtm->URL)[0]!='ptth' || psNextHtm->URL[4]!=':') httpscheme=0;
		xPtr=strrchr(psNextHtm->URL,':')+3;
		strcpy(psNextHtm->PATH,xPtr);
		xPtr=strrchr(psNextHtm->PATH,'/');
		if (xPtr!=0 && xPtr[1]==0){
			(dptr &xPtr[1])[0]='edni';
			(dptr &xPtr[5])[0]='th.x';
			(dptr &xPtr[9])[0]='m';
		};
		ReplaceUnwantedChars(psNextHtm->PATH);
		Attributes=GetFileAttributes(psNextHtm->PATH);
		strcpy(ErrBuff,psNextHtm->PATH);
		sLen=strlen(ErrBuff);
		if (sLen!=0){
			qchar=sLen-(strrchr(ErrBuff,'.')-ErrBuff);
			if (qchar<2 || qchar>6){
				(dptr &ErrBuff[sLen])[0]='mth.';
				ErrBuff[sLen+4]=0;
			};
		};
		qchar=GetFileAttributes(ErrBuff);
		if (qchar!=0xFFFFFFFF) Attributes=qchar;
		SetDlgItemText(hWin,ERR_OUTPUT,psNextHtm->URL);
		xPtr=pUrl;
		if (xPtr[-1]=='"') --xPtr;
		qchar=(dptr &xPtr[-4])[0]|D_LOWER;
		CurrHeader[0]=0;
		if (Attributes==0xFFFFFFFF && (LevelLoad!=0 || qchar=='=crs')){
			fSize=SizeURL(psNextHtm);
		}else{
			if (Attributes==0xFFFFFFFF){
				fSize=0xFFFFFFFE;
			}else{
				fSize=0;
			};
		};
		psNextHtm->cSize=fSize;
		if (LevelLoad==0 && Attributes==0xFFFFFFFF && qchar!='=crs'){
			do{
				--xPtr;
			}while (xPtr[0]!='<');
			qchar=(dptr &xPtr[1])[0]|D_LOWER;
			if (qchar!='knil'){
				psNextHtm->cSize=0xFFFFFFFE;
			}else{
				psNextHtm->cSize=SizeURL(psNextHtm);
			};
		};
		sLen=strlen(psNextHtm->PATH);
		if (sLen==0){
			psNextHtm->cSize=0xFFFFFFFF;
		}else{
			qchar=sLen-(strrchr(psNextHtm->PATH,'.')-psNextHtm->PATH);
			if (qchar<2 || qchar>6){
				(dptr &psNextHtm->PATH[sLen])[0]='mth.';
				psNextHtm->PATH[sLen+4]=0;
			};
		};
		if ((psNextHtm->cSize<=MaxFileSize && (CurrHeader[0]!=0 || httpscheme==0)) || Attributes!=0xFFFFFFFF){
			wsprintf(ErrBuff,PatternState,psNextHtm->URL,psNextHtm->PATH,psNextHtm->cSize,&Yes,psHtm->PATH,psHtm->uBase,&CurrHeader);	
			SetDlgItemText(hWin,ERR_OUTPUT,ErrBuff);
			strcpy(pCurrLog,ErrBuff);
			pCurrLog+=strlen(ErrBuff);
			ReplaceURLByRelativePath(psHtm,pUrl,psNextHtm->PATH);
		}else{
			if (CurrHeader[0]!=0){
				wsprintf(ErrBuff,PatternState,psNextHtm->URL,psNextHtm->PATH,psNextHtm->cSize,&No,psHtm->PATH,psHtm->uBase,&CurrHeader);
				strcpy(pCurrLog,ErrBuff);
				pCurrLog+=strlen(ErrBuff);
			};
			if (Attributes==0xFFFFFFFF){
				DeleteString(psHtm,pUrl,(psHtm->lpSearch-pUrl));
				InsertString(psHtm,pUrl,psNextHtm->URL);
			}else{
				ReplaceURLByRelativePath(psHtm,pUrl,psNextHtm->PATH);
			};
		};
		return TRUE;
	}else{
		return FALSE;
	};
};
void ReplaceURLByRelativePath(PHTML psHtm,LPSTR pUrl,LPSTR pPath){
char Buff[1024];
LPSTR xBase,xPath,xBuff,xUrl;
	xBase=psHtm->fBase;
	xPath=pPath;
	while (xBase[0]==xPath[0] && xPath[0]!=0){
		++xBase;
		++xPath;
	};
	xBuff=Buff;
	if (xPath[0]!=0){
		if (xBase[0]=='\\'){
			--xBase;
		};
		while (xBase[0]!='\\' && xBase>psHtm->fBase){
			--xBase;
		};
		if (xBase[0]=='\\'){
			++xBase;
		};
		if (xPath[0]=='\\'){
			--xPath;
		};
		while (xPath[0]!='\\' && xPath>pPath){
			--xPath;
		};
		if (xPath[0]=='\\'){
			++xPath;
		};
		while (TRUE){
			while (xBase[0]!='\\' && xBase[0]!=0){
				++xBase;
			};
			if (xBase[0]==0) break;
			++xBase;
			xBuff[0]='.';
			xBuff[1]='.';
			xBuff[2]='\\';
			xBuff+=3;
		};
	};
	strcpy(xBuff,xPath);
	xBuff=Buff;
	while (xBuff[0]!=0){
		if (xBuff[0]=='/'){
			xBuff[0]='\\';
		};
		++xBuff;
	};
	if (psHtm->lpSearch[0]==' '){
		--psHtm->lpSearch;
		psHtm->lpSearch[0]='"';
	};
	if (pUrl[-1]!='"'){
		pUrl[0]='"';
		++pUrl;
	};
	xBuff=Buff;
	xUrl=pUrl;
	do{
		xUrl[0]=xBuff[0];
		++xUrl;
		++xBuff;
	}while (xUrl<psHtm->lpSearch && xBuff[0]!=0);
	if (xUrl>=psHtm->lpSearch){
		if (xBuff[0]!=0){
			InsertString(psHtm,xUrl,xBuff);
		};
	}else{
		if ((psHtm->lpSearch-xUrl)!=0){
			DeleteString(psHtm,xUrl,psHtm->lpSearch-xUrl);
		};
	};
};
void ReplaceUnwantedChars(LPSTR pPath){
	while (pPath[0]!=0){
		if (pPath[0]==':' || pPath[0]=='?' || pPath[0]=='<' || pPath[0]=='>' || pPath[0]=='*' || pPath[0]=='|' || pPath[0]=='"'){
			pPath[0]='q';
		}else if (pPath[0]=='/'){
			pPath[0]='\\';
		};
		++pPath;
	};
};
void DeleteString(PHTML psHtm,LPSTR pStr,DWORD Len){
	memmove(pStr,pStr+Len,psHtm->lpCode+psHtm->cSize-pStr-Len);
	psHtm->cSize-=Len;
	psHtm->lpSearch-=Len;
	memset(psHtm->lpCode+psHtm->cSize,0,Len);
};
DWORD SizeURL(PHTML psHtm){
DWORD seconds;
	gSize=0xFFFFFFFE;
	hThreadSize=CreateThread(NULL,0,(LPTHREAD_START_ROUTINE) &SizeURL2,psHtm,NULL,&ThreadIDSize);	
	seconds=20;
	while (seconds>0){
		Sleep(1000);
		if (gSize!=0xFFFFFFFE) break;
		--seconds;
	};
	if (gSize==0xFFFFFFFE) TerminateThread(hThreadSize,0);
	return gSize;
};
DWORD CALLBACK SizeURL2(PHTML psHtm){
DWORD dwSize;
HANDLE hUrl;
char dwBuffer[512];
DWORD dwBufferLength,dwIndex;
LPSTR p_cx,p_cx2;
	dwSize=0xFFFFFFFE;
	hUrl=InternetOpenUrl(hInt,psHtm->URL,0,0,INTERNET_FLAG_NO_COOKIES|INTERNET_FLAG_RELOAD,0);
	dwSize=0;
	if (hUrl!=0){
		dwBufferLength=sizeof(dwBuffer);
		dwIndex=0;
		if (httpscheme==FALSE){
			InternetQueryDataAvailable(hUrl,&dwSize,0,0);
		}else{
			HttpQueryInfo(hUrl,HTTP_QUERY_RAW_HEADERS_CRLF,&dwBuffer,&dwBufferLength,&dwIndex);
			strcpy(CurrHeader,dwBuffer);
			_strlwr(dwBuffer);
			p_cx=strstr(dwBuffer,ContentLength);
			if (p_cx!=0){
				p_cx+=strlen(ContentLength)+1;
				dwSize=strtoul(p_cx,0,10);
			};
			p_cx=strstr(dwBuffer,ContentType);
			if (p_cx!=0){
				p_cx+=strlen(ContentType)+1;
				p_cx=strchr(p_cx,'/');
				if (p_cx!=0){
					++p_cx;
					p_cx2=p_cx;
					while (p_cx2[0]!=' ' && p_cx2[0]!=13 && p_cx2[0]!=';'){
						++p_cx2;
					};
					p_cx2[0]=0;
					FixExtension(psHtm->PATH,p_cx);
				};
			};
		};
		InternetCloseHandle(hUrl);
	};
	gSize=dwSize;
	return dwSize;
};
void FixExtension(LPSTR pPath,LPSTR ext){
LPSTR p_end;
	p_end=pPath+strlen(pPath);
	if (_strcmpi(&p_end[-4],".htm")!=0 && _strcmpi(&p_end[-5],".html")!=0){
		if (_strcmpi(ext,"html")==0){
			goto AppendExtension;
		};
	};
	if (p_end[-6]!='.' && p_end[-5]!='.' && p_end[-4]!='.' && p_end[-3]!='.' && p_end[-2]!='.'){
		goto AppendExtension;
	};
	if (_strcmpi(&p_end[-4],".php")==0 || _strcmpi(&p_end[-4],".asp")==0 ||
		_strcmpi(&p_end[-5],".aspx")==0 || _strcmpi(&p_end[-6],".phtml")==0){
		goto AppendExtension;
	};
	return;
AppendExtension:
	p_end[0]='.';
	strcpy(&p_end[1],ext);
};
void URLToAbsoluteURL(LPSTR pUrl,LPSTR pBase){
char ExtBuff[1024];
LPSTR p_slash;
PUSHORT p_dots;
	if ((wptr pUrl)[0]=='/.'){
		strcpy(&pUrl[0],&pUrl[1]);
	};
	if (strchr(pUrl,':')==0){
		strcpy(ExtBuff,pUrl);
		strcpy(pUrl,pBase);
		if (ExtBuff[0]=='.' && ExtBuff[1]=='.' && ExtBuff[2]=='/'){
			if (ExtBuff[3]!='/'){
				p_slash=strrchr(pUrl,'/');
				p_dots=wptr (&ExtBuff[0]);
				do{
					p_dots=wptr (sxb (p_dots)+3);
					do{
						--p_slash;
					}while (p_slash[0]!='/');
				}while (p_dots[0]=='..');
				strcpy(&p_slash[1],sxb p_dots);
			}else{
				p_slash=pUrl;
				do{
					p_slash++;
				}while ((wptr p_slash)[0]!='//');
				strcpy(&p_slash[2],&ExtBuff[4]);
			};
		}else if (ExtBuff[0]=='/'){
			if (ExtBuff[1]!='/'){
				strcpy(strchr(strchr(pUrl,'/')+2,'/'),ExtBuff);
			}else{
				p_slash=pUrl;
				do{
					p_slash++;
				}while ((wptr p_slash)[0]!='//');
				strcpy(p_slash,ExtBuff);
			};
		}else{
			strcat(pUrl,ExtBuff);
		};
	};
};
void main(void){

};